#pragma once
#include "Globals.h"
#include "WMAllocator.h"
#include "PacketTypeSystem.h"

namespace WorldMachine {
/**
 Composite types created by World Machine and available/required by all plugins.

 More of these will become available as time goes on
*/
	namespace Packet {
		/// UV map datatype (Core.uv)
		/// members:
		/// u,v : hfield for absolute U,V coordinate map
		extern UserTypeHandle uv; ///< UV map datatype

		/// Domain Distortion datatype (Core.distortion)
		/// members:
		/// u,v : hfield for U,V displacements from standard mapping
		/// scale : distance in world units to scale u,v by
		/// transform : transformation packet 
		extern UserTypeHandle distortion; ///< distortion datatype

		/// 3D distortion (Core.distortion3)
		extern UserTypeHandle distortion3; ///< distortion datatype

		extern UserTypeHandle rgba;  ///< rgb with an additional alpha channel
		extern UserTypeHandle ha;  ///< heightmap with an alpha channel

		extern UserTypeHandle vecfield2;

		extern UserTypeHandle water;
	}
}